
NUMPARTICLES      equ   24

ClearExplosion:   ld    hl,#ffff    ; out of range value clears explosion

; HL = screen position; H = pixels down, L = chars across
SetExplosionLocation:
                  ex    de,hl
                  ld    hl,ExplosionTable
                  ld    b,NUMPARTICLES
SetExL:           ld    (hl),e
                  inc   hl
                  ld    (hl),d
                  inc   hl
                  inc   hl
                  inc   hl
                  djnz  SetExL
                  ret

HandleExplosionParticles:
                  ld    a,EXPLOSIONTIMING
                  ld    (ExplosionTimer),a

                  ld    ix,ExplosionTable
                  ld    b,NUMPARTICLES
HExL1:            ld    a,(ix+0)
                  cp    32
                  jr    nc,HNextP
                  add   a,(ix+2)
                  cp    32
                  jr    nc,HNextP
                  ld    (ix+0),a
                  ld    l,a

                  ld    a,(ix+1)
                  cp    128
                  jr    nc,HNextP
                  add   a,(ix+3)
                  cp    128
                  jr    nc,HNextP
                  ld    (ix+1),a
                  ld    h,a
                
                  call  MapScreenAddress
                  ld    c,4
DrwEx1:           ld    a,r
                  ld    (hl),a
                  call  NextPixelLine
                  dec   c
                  jp    nz,DrwEx1
                  call  Scr2Attr
                  ld    a,r
                  and   7
                  or    64
                  ld    (hl),a

HNextP:           ld    de,4
                  add   ix,de
                  djnz  HExL1
                  ret

ExplosionTable:   db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    -1    ; add X
                  db    -8    ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    0     ; add X
                  db    -8    ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    1     ; add X
                  db    -8    ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    -1    ; add X
                  db    0     ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    1     ; add X
                  db    0     ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    -1    ; add X
                  db    8     ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    0     ; add X
                  db    8     ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    1     ; add X
                  db    8     ; add Y


                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    -2    ; add X
                  db    -16   ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    0     ; add X
                  db    -16   ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    2     ; add X
                  db    -16   ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    -2    ; add X
                  db    0     ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    2     ; add X
                  db    0     ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    -2    ; add X
                  db    16    ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    0     ; add X
                  db    16    ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    2     ; add X
                  db    16    ; add Y


                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    -3    ; add X
                  db    -48   ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    0     ; add X
                  db    -48   ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    3     ; add X
                  db    -48   ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    -3    ; add X
                  db    0     ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    3     ; add X
                  db    0     ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    -3    ; add X
                  db    48    ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    0     ; add X
                  db    48    ; add Y

                  db    -1    ; X - chars across
                  db    0     ; Y - pixels down
                  db    3     ; add X
                  db    48    ; add Y

