
floordir          db    0

SetupFloor:       ld    hl,floorattrs
                  ld    de,floorattrs+1
                  ld    bc,63
                  ld    (hl),68
                  ldir

                  ld    a,r
                  and   1
                  ld    (floordir),a

                  ld    a,(Level)
                  cp    9
                  ret   c

                  ld    hl,floorattrs+47
                  ld    (hl),0
                  inc   hl
                  ld    (hl),0
                  inc   hl
                  ld    (hl),0
                  ret

MoveFloorHole:    ld    a,FLOORTIMING
                  ld    (FloorTimer),a

                  ld    a,(floordir)
                  or    a
                  jp    nz,floorright

floorleft:        ld    de,floorattrs
                  ld    hl,floorattrs+1
                  ld    bc,63
                  ld    a,(de)
                  ldir
                  ld    (de),a
                  ret

floorright:       ld    de,floorattrs+63
                  ld    hl,floorattrs+62
                  ld    bc,63
                  ld    a,(de)
                  lddr
                  ld    (de),a
                  ret

DrawFloor:        ld    hl,(floorposn)
                  call  MapScreenAddress
                  push  hl

                  ld    b,32
drfl1:            push  bc
                  push  hl
                  ld    de,floorgfx
                  ld    b,8
drfl2:            ld    a,(de)
                  ld    (hl),a
                  inc   de
                  inc   h
                  djnz  drfl2
                  pop   hl
                  inc   l
                  pop   bc
                  djnz  drfl1

                  pop   hl
                  call  Scr2Attr
                  ex    de,hl
                  ld    hl,floorattrs
                  ld    bc,32
                  ldir
                  ret

floorgfx:         db    170,213,55,101,92,231,137,76

floorattrs:       ds    64

floorposn         dw    0
