
ClrScrollText:    ld    hl,NullText
                  ld    (scrollptr),hl
                  ret

SetScrollText:    ld    (scrollptr),hl
                  inc   hl
                  ld    (hl),22     ; set starting Y position of text
                  ld    a,20
                  ld    (scrolltimer),a
                  ret

MoveScrollText:   ld    hl,(scrollptr)
                  ld    a,(hl)
                  or    a
                  ret   z

                  inc   hl
                  ld    a,(hl)
                  or    a
                  jr    z,ClrScrollText

                  cp    8
                  jr    nz,Scroll_Up

                  ld    a,(scrolltimer)
                  or    a
                  jr    z,Scroll_Up
                  dec   a
                  ld    (scrolltimer),a

                  ld    a,(scrolltoggle)
                  xor   1
                  ld    (scrolltoggle),a
                  ret   nz
                  jr    DrawScrollText

Scroll_Up:        dec   (hl)

DrawScrollText:   dec   hl
                  ex    de,hl
                  jp    WriteText

Scroll_ExtraLife: db    C_AT, 0, 10
                  db    C_INK, 7
                  db    C_DOUBLE
                  db    "EXTRA LIFE !"
                  db    C_SINGLE
                  db    0

Scroll_LastLife:  db    C_AT, 0, 4
                  db    C_INK, 2
                  db    C_DOUBLE
                  db    "THIS IS YOUR LAST LIFE !"
                  db    C_SINGLE
                  db    0

Scroll_DontFall:  db    C_AT, 0, 10
                  db    C_INK, 4
                  db    C_DOUBLE
                  db    "DON'T FALL !"
                  db    C_SINGLE
                  db    0

scrollptr         dw    0
scrolltimer       db    0
scrolltoggle      db    0
NullText:         db    0


