
invadertonenum    db    0
invadertonecnt    db    0

; channel A = invader movement tones
; channel B = explosion

InitAY:           ld    de,#0ba0
                  call  OutAY
                  ld    de,#0c04
                  call  OutAY

                  ld    de,#061f
                  call  OutAY

                  ld    d,7
                  ld    e,%00101110
                  call  OutAY

                  xor   a
                  ld    (invadertonenum),a
                  ld    (invadertonecnt),a
                  ret

SetExplosionSound:
                  ld    de,#090f
                  jp    OutAY

InvaderTone:      ld    a,(invadertonecnt)
                  inc   a
                  and   3
                  ld    (invadertonecnt),a
                  ret   nz

                  ld    a,(invadertonenum)
                  inc   a
                  and   3
                  ld    (invadertonenum),a
                  ld    h,0
                  ld    l,a
                  add   hl,hl
                  ld    de,InvToneTable
                  add   hl,de
                  ld    e,(hl)
                  inc   hl
                  ld    d,(hl)
                  ex    de,hl

                  ld    d,0
                  ld    e,l
                  call  OutAY
                  inc   d
                  ld    e,h
                  call  OutAY

                  ld    de,#0810
                  call  OutAY
                  ld    de,#0d02
                  call  OutAY
                  ret

KillAY:           ld    de,#0800
                  call  OutAY
                  ld    de,#0900
                  call  OutAY
                  ld    de,#0a00
                  call  OutAY
                  ret

OutAY:            ld    bc,#fffd
                  out   (c),d
                  ld    b,#bf
                  out   (c),e
                  ret

InvToneTable:     db    136, 4
                  db    0, 5
                  db    120, 5
                  db    240, 5

