
plotstarfield:    ld    hl,star_mod_opcode
                  ld    a,(manmoved)
                  or    a
                  jr    z,nomovestars

                  ld    a,(mandir)
                  or    a
                  jr    z,movestarsleft

movestarsright:   ld    (hl),134    ; ADD A,(HL)
                  jp    plotallstars

movestarsleft:    ld    (hl),150    ; SUB (HL)
                  jp    plotallstars

nomovestars:      ld    (hl),0      ; NOP

plotallstars:     ld    hl,starfielddata
                  ld    b,(hl)
                  inc   hl

pltsl1:           push  bc
                  push  hl

                  inc   hl
                  ld    a,(hl)      ; x
                  inc   hl

star_mod_opcode:  sub   (hl)        ; -speed

                  dec   hl
                  ld    (hl),a      ; store new x
                  dec   hl          ; hl->y

                  ld    a,(hl)      ; a=y
                  inc   hl
                  ld    c,(hl)      ; c=x

                  ld    h,0
                  ld    l,a
                  add   hl,hl
                  ld    de,scrtable
                  add   hl,de
                  ld    e,(hl)
                  inc   hl
                  ld    d,(hl)      ; de=vertical screen posn

                  ld    a,c
                  rra
                  rra
                  rra
                  and   31
                  add   a,e
                  ld    e,a         ; de=screen posn of star

                  ld    hl,starbitdata
                  ld    b,0
                  ld    a,c
                  and   7
                  ld    c,a
                  add   hl,bc       ; hl->star bit data

                  ex    de,hl
                  ld    a,(de)
                  or    (hl)
                  ld    (hl),a      ; plot star

                  ld    a,h
                  rrca
                  rrca
                  rrca
                  and   3
                  or    &d8
                  ld    h,a
                  ld    a,(hl)
                  cp    71
                  jr    nz,pltsk1
                  ld    a,r
                  and   7
                  or    1
                  ld    (hl),a

pltsk1:           pop   hl
                  pop   bc
                  inc   hl
                  inc   hl
                  inc   hl
                  djnz  pltsl1
                  ret


starbitdata:      db    128,64,32,16,8,4,2,1

; max y=143
starfielddata:
                  db    17    ; no. of stars

                  db    8,   200, 3    ; y, x, speed
                  db    16,  120, 4    ; y, x, speed
                  db    24,  26,  1    ; y, x, speed
                  db    32,  220, 5    ; y, x, speed
                  db    40,  60,  3    ; y, x, speed
                  db    48,  140, 2    ; y, x, speed
                  db    56,  170, 1    ; y, x, speed
                  db    64,  248, 2    ; y, x, speed
                  db    72,  8,   5    ; y, x, speed
                  db    80,  11,  2    ; y, x, speed
                  db    88,  33,  3    ; y, x, speed
                  db    96,  91,  1    ; y, x, speed
                  db    104, 119, 4    ; y, x, speed
                  db    112, 55,  2    ; y, x, speed
                  db    120, 203, 1    ; y, x, speed
                  db    128, 130, 3    ; y, x, speed
                  db    136, 44,  4    ; y, x, speed

